; =============== S U B	R O U T	I N E =======================================
doFountain:				; CODE XREF: game_move_items+29 p
		ld	a, (_Flag_Scene_) ; 0 1	- FishPool
					; 1 2 -	Rope
					; 2 4 -	JumpTubles
					; 3 8 -	4 Fountain
					; 4 1 -	5 Tumb
					; 5 2 -	Vegetables
					; 6 4 -	Fire
					; 7 8 -	Pool Flag
		and	8
		ret	z
;
		ld	de,  VLINE+(10*32)+8
		ld	a, (RopePhase1)
		call	DisplayFountain
		ld	(Fountain_YY), a
;
		ld	de,  VLINE+(10*32)+17
		ld	a, (FuntainPhase3)
		call	DisplayFountain
		ld	(Fountain_YY+2), a
;
		ld	de,  VLINE+(10*32)+12
		ld	a, (RopePhase2)
		call	DisplayFountain
		ld	(Fountain_YY+1), a
;
		ld	de,  VLINE+(10*32)+21
		ld	a, (FuntainPhase4)
		call	DisplayFountain
		ld	(Fountain_YY+3), a

;ESL_KORVET
		ld	a,M_SCR2_FOUNTAIN
        	ld  	(scr2_pnt_mode),a

;moved to _scene_fountain
;		ld	hl, FountainInWater
;		call	xStringToVram_HL
;		ld	a, 0CBh	; 'Ë'   ; FountainStart
;		ld	de,  VLINE+(17*32)+9
;		call	vdp_wr_de_a
;		ld	de,  VLINE+(17*32)+22
;		call	vdp_wr_de_a
;		ld	a, 0CCh	; 'Ì'   ; FountainStart
;		ld	de,  VLINE+(17*32)+13
;		call	vdp_wr_de_a
;		ld	de,  VLINE+(17*32)+18
;		call	vdp_wr_de_a
		ret
; End of function doFountain

; ---------------------------------------------------------------------------
FountainInWater:
		dw VLINE+(16*32)+8		; DATA XREF: doFountain+36 o
		db    7,0CDh,0C6h,0C6h,0C7h,0CEh,0C7h,0C7h,0C7h,0C7h,0CEh,0C7h,0C6h,0C6h,0CDh,	 7,0FFh


; =============== S U B	R O U T	I N E =======================================
;cf=1 if player should dye

Check_Fountain:				; CODE XREF: _do_player_move:noJump p

		ld	de, Fountain_YY
		ld	hl, PlayerYPos
		ld	a, (PlayerXPos)
		ld	b, a
		cp	56
		jp	c, L652C
		cp	81
		jp	nc, L652C
		ld	a, (de)
		add	a, 4
		sub	(hl)
		jp	c, L652C
		cp	9
		jp	nc, L652C
		jp	L656C
; ---------------------------------------------------------------------------

L652C:					; CODE XREF: Check_Fountain+C j
					; Check_Fountain+10 j ...
		inc	de
		ld	a, b
		cp	88
		jp	c, L6542
		cp	113
		jp	nc, L6542
		ld	a, (de)
		add	a, 4
		sub	(hl)
		jp	c, L6542
		cp	9
		jp	nc, L6542
		jp	L656C
; ---------------------------------------------------------------------------

L6542:					; CODE XREF: Check_Fountain+22 j
					; Check_Fountain+26 j ...
		inc	de
		ld	a, b
		cp	128
		jp	c, L6558
		cp	153
		jp	nc, L6558
		ld	a, (de)
		add	a, 4
		sub	(hl)
		jp	c, L6558
		cp	9
		jp	nc, L6558
		jp	L656C
; ---------------------------------------------------------------------------

L6558:					; CODE XREF: Check_Fountain+38 j
					; Check_Fountain+3C j ...
		inc	de
		ld	a, b
		cp	160
		jp	c, L657E
		cp	185
		jp	nc, L657E
		ld	a, (de)
		add	a, 4
		sub	(hl)
		jp	c, L657E
		cp	9
		jp	nc, L657E

L656C:
		ld	a, wm_fountain ;4
		ld	(WalkMode), a
		
		ld	a, (PlayerYPos)
		ld	hl, unk_E13A
		sub	10h
		cp	(hl)
		jp	c, L657E
		scf 				;player should dye
		ret
; ---------------------------------------------------------------------------

L657E:					; CODE XREF: Check_Fountain+4E j
					; Check_Fountain+52 j ...
		or	a
		ret
; End of function Check_Fountain




; =============== S U B	R O U T	I N E =======================================


DisplayFountain:			; CODE XREF: doFountain+C p
					; doFountain+18 p ...
		and	1Fh
		cp	18
		jp	c, L60C2
;esl		
;		neg
		cpl
		add a,1
;esl		
		inc	a
		and	1Fh

L60C2:					; CODE XREF: DisplayFountain+4 j
		ld	hl, FountaiTable
		rlca
		call	add_a_hl
		push	de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		pop	de
		ld	bc, 603h
		call	CopyToVRAM_ROW
		ld	a, (hl)
		ret
; End of function DisplayFountain

FountaiTable:
		dw _FT01		; DATA XREF: DisplayFountain:L60C2 o
		dw _FT02
		dw _FT03
		dw _FT04
		dw _FT05
		dw _FT06
		dw _FT07
		dw _FT08
		dw _FT10
		dw _FT11
		dw _FT12
		dw _FT13
		dw _FT14
		dw _FT15
		dw _FT16
		dw _FT17
		dw _FT18
		dw _FT19
_FT01:		db    0,   0,	0	; DATA XREF: RAM:FountaiTable o
		db    0,   0,	0
		db    0,   0,	0
		db    0,   0,	0
		db 0B3h,0B4h,0B5h
		db 0C3h,0C4h,0C5h
		db 82
_FT02:		db    0,   0,	0	; DATA XREF: RAM:56DF o
		db    0,   0,	0
		db    0,   0,	0
		db    0,   0,	0
		db 0B2h,0B2h,0B2h
		db 0BFh,0BEh,0C0h
		db 82
_FT03:		db    0,   0,	0	; DATA XREF: RAM:56E1 o
		db    0,   0,	0
		db    0,   0,	0
		db 0B6h,0B6h,0B6h
		db 0BAh,0BBh,0BCh
		db 0CDh,0CEh,0CFh
		db 78
_FT04:		db    0,   0,	0	; DATA XREF: RAM:56E3 o
		db    0,   0,	0
		db    0,   0,	0
		db 0B6h,0B6h,0B6h
		db 0B7h,0B8h,0B9h
		db 0C8h,0C9h,0CAh
		db 78
_FT05:		db    0,   0,	0	; DATA XREF: RAM:56E5 o
		db    0,   0,	0
		db    0,   0,	0
		db 0B3h,0B4h,0B5h
		db 0C3h,0C4h,0C5h
		db    0,0BDh,	0
		db 74
_FT06:		db    0,   0,	0	; DATA XREF: RAM:56E7 o
		db    0,   0,	0
		db    0,   0,	0
		db 0B2h,0B2h,0B2h
		db 0BFh,0BEh,0C0h
		db    0,0BDh,	0
		db 74
_FT07:		db    0,   0,	0	; DATA XREF: RAM:56E9 o
		db    0,   0,	0
		db 0B6h,0B6h,0B6h
		db 0BAh,0BBh,0BCh
		db 0CDh,0CEh,0CFh
		db    0,0BDh,	0
		db 70
_FT08:		db    0,   0,	0	; DATA XREF: RAM:56EB o
		db    0,   0,	0
		db 0B6h,0B6h,0B6h
		db 0B7h,0B8h,0B9h
		db 0C8h,0C9h,0CAh
		db    0,0BDh,	0
		db 70
_FT10:		db    0,   0,	0	; DATA XREF: RAM:56ED o
		db    0,   0,	0
		db 0B3h,0B4h,0B5h
		db 0C3h,0C4h,0C5h
		db    0,0BDh,	0
		db    0,0BDh,	0
		db 66
_FT11:		db    0,   0,	0	; DATA XREF: RAM:56EF o
		db    0,   0,	0
		db 0B2h,0B2h,0B2h
		db 0BFh,0BEh,0C0h
		db    0,0BDh,	0
		db    0,0BDh,	0
		db 66
_FT12:		db    0,   0,	0	; DATA XREF: RAM:56F1 o
		db 0B6h,0B6h,0B6h
		db 0BAh,0BBh,0BCh
		db 0CDh,0CEh,0CFh
		db    0,0BDh,	0
		db    0,0BDh,	0
		db 62
_FT13:		db    0,   0,	0	; DATA XREF: RAM:56F3 o
		db 0B6h,0B6h,0B6h
		db 0B7h,0B8h,0B9h
		db 0C8h,0C9h,0CAh
		db    0,0BDh,	0
		db    0,0BDh,	0
		db 62
_FT14:		db    0,   0,	0	; DATA XREF: RAM:56F5 o
		db 0B3h,0B4h,0B5h
		db 0C3h,0C4h,0C5h
		db    0,0BDh,	0
		db    0,0BDh,	0
		db    0,0BDh,	0
		db 58
_FT15:		db    0,   0,	0	; DATA XREF: RAM:56F7 o
		db 0B2h,0B2h,0B2h
		db 0BFh,0BEh,0C0h
		db    0,0BDh,	0
		db    0,0BDh,	0
		db    0,0BDh,	0
		db 58
_FT16:		db 0B6h,0B6h,0B6h	; DATA XREF: RAM:56F9 o
		db 0BAh,0BBh,0BCh
		db 0CDh,0CEh,0CFh
		db    0,0BDh,	0
		db    0,0BDh,	0
		db    0,0BDh,	0
		db 54
_FT17:		db 0B6h,0B6h,0B6h	; DATA XREF: RAM:56FB o
		db 0B7h,0B8h,0B9h
		db 0C8h,0C9h,0CAh
		db 0CBh,0BDh,0CCh
		db    0,0BDh,	0
		db    0,0BDh,	0
		db 54
_FT18:		db 0B3h,0B4h,0B5h	; DATA XREF: RAM:56FD o
		db 0C3h,0C4h,0C5h
		db 0C6h,0BDh,0C7h
		db    0,0BDh,	0
		db    0,0BDh,	0
		db    0,0BDh,	0
		db 50
_FT19:		db 0B2h,0B2h,0B2h	; DATA XREF: RAM:56FF o
		db 0BFh,0BEh,0C0h
		db 0C2h,0BDh,0C1h
		db    0,0BDh,	0
		db    0,0BDh,	0
		db    0,0BDh,	0
		db 50

