; =============== S U B	R O U T	I N E =======================================


CheckTimeNearEnd:			; CODE XREF: game_move_items+20 p
		ld	hl, Time0
		ld	a, (hl)
		ld	c, a
		cp	16
		jp	nc, L65CB
		ld	a, SPR_FaceSad2
		call	UpdateLifeSprite
		ld	a, c
		cp	2
		ret	z
		ld	a, (inGameTick)
		and	3Fh ; '?'
		jp	nz, L65CB
		ld	a, mTimeOut
		call	SelectMUSIC_A

L65CB:					; CODE XREF: CheckTimeNearEnd+7 j
					; CheckTimeNearEnd+17 j
		ld	a, (inGameTick)
		and	0FFh
		ret	nz
; End of function CheckTimeNearEnd


; =============== S U B	R O U T	I N E =======================================


DecTimeUpdateScreen:			; CODE XREF: RAM:4387 p
		ld	hl, Time0
		ld	a, (hl)
		cp	2
		ret	z
; End of function DecTimeUpdateScreen

; START	OF FUNCTION CHUNK FOR putTIME

displayTime:				; CODE XREF: putTIME+6 j
;esl
;		ld	de, (TimeUpdateScrAddr)
		ex 	hl,de
		ld	hl, (TimeUpdateScrAddr)
		ex 	hl,de

		ld	a, (hl)
		and	3
		add	a, 11h
		cp	13h
		jp	nz, L65E6
		dec	de

L65E6:					; CODE XREF: putTIME-2A j
		call	vdp_wr_de_a
		dec	(hl)
		ex	de, hl
		ld	(TimeUpdateScrAddr), hl
		ex	de, hl
		push	de
		ld	a, 3Dh ; '='
		sub	e
		jp	z, L65FE
		ld	b, a

L65F6:					; CODE XREF: putTIME-11 j
		inc	de
		ld	a, 14h		; chr. Time OUT	red
		call	vdp_wr_de_a
		
		;djnz
		dec b
		jp nz,L65F6


L65FE:					; CODE XREF: putTIME-1A j
		pop	de
		ld	a, e
		sub	48
		ret	z
		ld	b, a

L6604:					; CODE XREF: putTIME-3 j
		dec	de
		ld	a, 2Fh ; '/'    ; chr. Time OK blue
		call	vdp_wr_de_a
		
		;djnz
		dec b
		jp nz,L6604

		ret
; END OF FUNCTION CHUNK	FOR putTIME

; =============== S U B	R O U T	I N E =======================================


putTIME:				; CODE XREF: DispalyMessages+1E p

; FUNCTION CHUNK AT 65D8 SIZE 00000035 BYTES

		ld	hl, Time0
		ld	a, (hl)
		cp	2
		jp	nz, displayTime
;
		ld	de,  VLINE+(1*32)+16
		ld	b, 14

L661A:					; CODE XREF: putTIME+13 j
		ld	a, 14h		; EmptyTime
		call	vdp_wr_de_a
		inc	de
		
		;djnz
		dec b
		jp nz,L661A		; EmptyTime

		ret
; End of function putTIME
