; =============== S U B	R O U T	I N E =======================================

ML_5_Delay_BeforeDemo:			; DATA XREF: RAM:4153 o
		ld	hl, _ml_delay
		dec	(hl)
		ret	nz
		jp	MainLoopNext_Deay50
; End of function ML_5_Delay_BeforeDemo


; =============== S U B	R O U T	I N E =======================================


ML_6_DemoStartClearScreenPrepareLevel:	; DATA XREF: RAM:4155 o
		ld	a, 0FFh
		ld	(byte_E00F), a
		call	ClearFromCenter
		ret	p
;
;ESL_KORVET
		call 	SelectGameFont
;ESL_KORVET


		call	Init_For_Demo
;
		xor	a
		ld	(byte_E00F), a
		jp	MainLoopNEXT
; End of function ML_6_DemoStartClearScreenPrepareLevel


; =============== S U B	R O U T	I N E =======================================


ML_7_DemoLoop:				; DATA XREF: RAM:4157 o
		call	DemoControl
;
		ld	hl, byte_E00C
		xor	a
		cp	(hl)
		jp	nz, L41E5

		inc	hl
		inc	hl
		cp	(hl)				; ?? byte_E00E : PlayerLevelEnterSide
		ret	z
;
		ld	a, 17 				; goto _ML_17
		jp	MainLoopGotoStepDelay50
; ---------------------------------------------------------------------------

L41E5:					; CODE XREF: ML_7_DemoLoop+8 j
					; RAM:440E j
		ld	a, 1
		ld	(RequireClear),	a
		
		xor	a
		ld	(hl), a

MainLoopGotoStepDelay50:					; CODE XREF: ML_7_DemoLoop+10 j
					; ML_11_inGame+17 j
		ld	(MainLoopStepCounter), a
		jp	MainLoopNext_Deay50
; End of function ML_7_DemoLoop

; =============== S U B	R O U T	I N E =======================================


DemoControl:				; CODE XREF: ML_7_DemoLoop p
		ld	a, (Scene)
		or	a
		jp	nz, dScene1
;
		ld	hl, KeyCurrent	; b0: Up b1:Down b2:Left b3:Right b4:A b5:B
		ld	a, 8
		ld	(hl), a
		ld	a, (PlayerXPos)
		cp	56		; First	Jump
		jp	z, L58C9
		cp	128		; Second Jump
		jp	nz, L58CE

L58C9:					
					
		ld	(hl), 38h ; '8'
		dec	hl
		ld	(hl), 0

L58CE:					
		jp	g_game_move_items
; ---------------------------------------------------------------------------

dScene1:				
		dec	a
		jp	nz, g_game_move_items
;
		ld	hl, PlayerXPos

		ld	a, (WalkMode)
		or	a 				; 0 walk
		jp	z, L58E8 

		dec	a 				; 1 jump
		jp	z, g_game_move_items

		dec	a 				; 2 onrope
		jp	z, L591C

		cp	3 				; 3 wm_jumping_tumb
		jp	z, L5925

		jp	g_game_move_items
; ---------------------------------------------------------------------------

L58E8:					; CODE XREF: DemoControl+28 j
		ld	a, (hl)
		cp	0B0h ; '°'
		jp	nc, L5914
		sub	4
		cp	2Ah ; '*'
		jp	c, L5914
		ld	a, (inGameTick)
		and	3
		jp	z, L5904
;
		ld	a, (_PlayerFlag_) ; 0 1
					; 1 2
					; 2 4 -	1 KeyLeftLeft
					; 3 8 -	1 KeyRight
					; 4 1
					; 5 2
					; 6 4
					; 7 8
		xor	0Ch

L58FF:					; CODE XREF: DemoControl+60 j
					; DemoControl+65 j ...
		ld	(KeyCurrent), a	; b0: Up b1:Down b2:Left b3:Right b4:A b5:B
		jp	g_game_move_items
; ---------------------------------------------------------------------------

L5904:					; CODE XREF: DemoControl+46 j
;esl
;		ld	a, r
		call 	rand_8
;esl		
		and	7Fh ; ''
		ld	(inGameTick), a
		ld	hl, KeyPrev	; b0: Up b1:Down b2:Left b3:Right b4:A b5:B
		ld	(hl), 0
		ld	a, 30h ; '0'
		jp	L58FF
; ---------------------------------------------------------------------------

L5914:					; CODE XREF: DemoControl+39 j
					; DemoControl+3F j ...
		ld	a, (_PlayerFlag_) ; 0 1
					; 1 2
					; 2 4 -	1 KeyLeftLeft
					; 3 8 -	1 KeyRight
					; 4 1
					; 5 2
					; 6 4
					; 7 8
		jp	L58FF
; ---------------------------------------------------------------------------

g_game_move_items:					; CODE XREF: DemoControl:L58CE j
					; DemoControl+1F j ...
		jp	game_move_items
; ---------------------------------------------------------------------------

L591C:					; CODE XREF: DemoControl+2E j
		ld	a, (inGameTick)
		and	7Fh ; ''
		jp	z, L5932
		jp	L5914
; ---------------------------------------------------------------------------

L5925:					; CODE XREF: DemoControl+32 j
		ld	a, (_Sprite_10_BridgeRight+sprX)
		cp	(hl)
		jp	nc, L5914
		cp	0A4h ; '¤'
		jp	nc, L5932
		xor	a
		jp	L58FF
; ---------------------------------------------------------------------------

L5932:
		ld	hl, KeyCurrent	; b0: Up b1:Down b2:Left b3:Right b4:A b5:B
		jp	L58C9
; End of function DemoControl


; =============== S U B	R O U T	I N E =======================================


Init_For_Demo:				; CODE XREF: ML_6_DemoStartClearScreenPrepareLevel+9 p
		call	InitFONT_Ascii_30_5F
		call	InitFontsAndSprites
		call	InitPlayerData
		call	DispalyMessages
		jp	initPlayerAndSprites
