_LDIR_:
		push 	af
_LDIR1_:
		LD 		A,(HL)
		LD 		(DE),A
		INC 	HL
		INC 	DE
		DEC 	BC
		ld 		a,c
		or 		b
		jp 		nz,_LDIR1_
		pop 	af
		ret 

;from tim0xA
; 	  sta	$+19	  ; sbc	  HL, DE
; 	  mov	a, l	  ;
; 	  sbb	e	  ;
; 	  mov	l, a	  ;
; 	  mov	a, h	  ;
; 	  sbb	d	  ;
; 	  mov	h, a	  ;
; 	  jc	$+7	  ;
; 	  ora	l	  ;
; 	  jmp	$+5	  ;
; 	  ora	l	  ;
; 	  stc	 	  ;
; 	  mvi	a, 000h	  ;


; sbc	  HL, DE
sbchlde:
	;do not save af
 	ld	a, l	  
 	sbc	e	  
 	ld	l, a	  

 	ld	a, h	  
 	sbc	d	  
 	ld	h, a	  

 	jp 	c,	sbm7	  
 	or	l	  
 	jp	sbm5  
sbm7: 
	or	l	  
 	scf	 	  
sbm5: ret

; returns pseudo random 8 bit number in A. Only affects A.
; (r_seed) is the byte from which the number is generated and MUST be	
; initialised to a non zero value or this function will always return
; zero. Also r_seed must be in RAM, you can see why......

rand_8:
	call _rand_8 	;esl (try more random ?)
	call _rand_8 	;esl (try more random ?)
	
_rand_8:
	LD	A,(r_seed)	; get seed
	AND	0B8h		; mask non feedback bits
	SCF			; set carry
	JP	PO,no_clr	; skip clear if odd
	CCF			; complement carry (clear it)
no_clr:
	LD	A,(r_seed)	; get seed back
	RLA			; rotate carry into byte
	LD	(r_seed),A	; save back for next prn
	RET			; done

;r_seed:
;	DB	1		; prng seed byte (must not be zero)

;another candidat to random
;http://wikiti.brandonw.net/index.php?title=Z80_Routines:Math:Random
;-----> Generate a random number
; ouput a=answer 0<=a<=255
; all registers are preserved except: af
;random:
;        push    hl
;        push    de
;        ld      hl,(randData)
;        ld      a,r
;        ld      d,a
;        ld      e,(hl)
;        add     hl,de
;        add     a,l
;        xor     h
;        ld      (randData),hl
;        pop     de
;        pop     hl
;        ret



; =============== S U B	R O U T	I N E =======================================


add_a_hl:				; CODE XREF: jp_CASE_A+2 p
					; CheckGameStartKeys+13 p ...
		add	a, l
		ld	l, a
		ret	nc
		inc	h
		ret
; End of function add_a_hl


; =============== S U B	R O U T	I N E =======================================


add_a_de:				; CODE XREF: ML_8_MenuBlink+47 p
					; ClearFromCenter+2B p ...
		add	a, e
		ld	e, a
		ret	nc
		inc	d
		ret
; End of function add_a_de

; =============== S U B	R O U T	I N E =======================================


jp_CASE_A:				; CODE XREF: RAM:4146 p	ML_8_MenuBlink+3 p ...
		add	a, a
		pop	hl
		call	add_a_hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		jp	(hl)
; End of function jp_CASE_A

; =============== S U B	R O U T	I N E =======================================


SwapArea_hl_de_bc:			; CODE XREF: RAM:4331 p
					; SwapArea_hl_de_bc+7 j
		ld	c, (hl)
		ld	a, (de)
		ld	(hl), a
		ld	a, c
		ld	(de), a
		inc	hl
		inc	de
		
		;djnz
		dec b
		jp nz,SwapArea_hl_de_bc

		ret
; End of function SwapArea_hl_de_bc
