;configuration 0x6c should be already set 
;for routines


        macro   spr_show _spr_data_,_label_
                ld      hl,_spr_data_
                call    GetSpriteAddr        ;hl (to), de (from)
                ld      (_label_),hl
                call    c,sprite_show_1
        endm

        macro   spr_erase _label_
                ;ld      hl,_label_
                db      21h
_label_:
                dw      0
                ld      a,h
                or      l
                call    nz,sprite_erase_1
        endm

SS0=$


process_sprite:
        ;di
waitVBL:
        ld      a,(0fb38h)
        and     2
        jp      nz,waitVBL


        ld      a, 6Ch
        ld      (regbase1C+SYSREG), a

        call    sprites_erase
        call    sprites_show

        ld      a, 1Ch
        ld      (regbase6C+SYSREG), a
        ;ei
        ret

process_sprite_erase:
        ;di
        ld      a, 6Ch
        ld      (regbase1C+SYSREG), a

        call    sprites_erase
        ;call    sprites_show

        ld      a, 1Ch
        ld      (regbase6C+SYSREG), a
        ;ei
        ret


sprites_show:
        xor     a
        ld      (sprite_show__cntr),a

        ld      a, _WL__2|_LAYER_MODE_W|1
        ld      (regbase6C+NCREG), a

;        spr_show spr00_data,spr00_erase
;        spr_show spr01_data,spr01_erase
;        spr_show spr02_data,spr02_erase
;        spr_show spr03_data,spr03_erase

;        spr_show spr04_data,spr04_erase
        spr_show spr05_data,spr05_erase
        spr_show spr06_data,spr06_erase
;        spr_show spr07_data,spr07_erase
        spr_show spr08_data,spr08_erase
        spr_show spr09_data,spr09_erase

        spr_show spr10_data,spr10_erase
        spr_show spr11_data,spr11_erase
        spr_show spr12_data,spr12_erase
        spr_show spr13_data,spr13_erase
        spr_show spr14_data,spr14_erase
        spr_show spr15_data,spr15_erase
        spr_show spr16_data,spr16_erase
        spr_show spr17_data,spr17_erase
        spr_show spr18_data,spr18_erase
        spr_show spr19_data,spr19_erase

        spr_show spr20_data,spr20_erase
;        spr_show spr21_data,spr21_erase
        spr_show spr22_data,spr22_erase
        spr_show spr23_data,spr23_erase
 ;       spr_show spr24_data,spr24_erase
 ;       spr_show spr25_data,spr25_erase
 ;       spr_show spr26_data,spr26_erase

;        spr_show spr27_data,spr27_erase
;        spr_show spr28_data,spr28_erase
;        spr_show spr29_data,spr29_erase
;        spr_show spr30_data,spr30_erase

;        spr_show spr31_data,spr31_erase

        ret
sprite_show__cntr:      db      0
sprite_show__cntr2:      db      0

sprite_show_1:
        ld      a,(sprite_show__cntr)
        inc     a
        ld      (sprite_show__cntr),a


        ld      a,(sprite_show__cntr2)
        inc     a
        ld      (sprite_show__cntr2),a

        ld      bc,64-2
        ld      a,0ffh
        dup     16
                ld      a,(de)
                ld      (hl), a
                inc     hl
                inc     de
                ld      a,(de)
                ld      (hl), a
                inc     hl
                inc     de
                ld      a,(de)
                ld      (hl), a
                ;inc     hl
                inc     de
                add     hl, bc
        edup
        ret

sprites_erase:
        xor     a
        ld      (sprite_erase__cntr),a

        ld      a, _WL__2|_LAYER_MODE_W|0
        ld      (regbase6C+NCREG), a
        ld      bc,64-2

;        spr_erase spr00_erase
;        spr_erase spr01_erase
;        spr_erase spr02_erase
;        spr_erase spr03_erase

;        spr_erase spr04_erase
        spr_erase spr05_erase
        spr_erase spr06_erase
;        spr_erase spr07_erase
        spr_erase spr08_erase
        spr_erase spr09_erase

        spr_erase spr10_erase
        spr_erase spr11_erase
        spr_erase spr12_erase
        spr_erase spr13_erase
        spr_erase spr14_erase
        spr_erase spr15_erase
        spr_erase spr16_erase
        spr_erase spr17_erase
        spr_erase spr18_erase
        spr_erase spr19_erase

        spr_erase spr20_erase
;        spr_erase spr21_erase
        spr_erase spr22_erase
        spr_erase spr23_erase
;        spr_erase spr24_erase
;        spr_erase spr25_erase
;        spr_erase spr26_erase

;        spr_erase spr27_erase
;        spr_erase spr28_erase
;        spr_erase spr29_erase
;        spr_erase spr30_erase

;        spr_erase spr31_erase

        ret

sprite_erase__cntr:     db      0
sprite_erase__cntr2:     db      0

sprite_erase_1:
        ld      a,(sprite_erase__cntr)
        inc     a
        ld      (sprite_erase__cntr),a

        ld      a,(sprite_erase__cntr2)
        inc     a
        ld      (sprite_erase__cntr2),a

        ld      a,0ffh
                dup     16
                ld      (hl), a
                inc     hl
                ld      (hl), a
                inc     hl
                ld      (hl), a
                add     hl, bc
        edup
        ret


;       db y,x,sprid,color
;de - sprptr
;hl - scraddr

GetSpriteAddr:
        ld      a, (hl)
        cp      192
        jp      c, get_new_spr_addr     ; y < 192 ?
noSprite:
        ld      hl, 0
        ld      d, b
        ld      e, c
        ret

;a - sprid*4
;b - x
;c - y

;hl - sprptr
;de - scraddr

get_new_spr_addr:
        ld      c,a
        inc     hl
        ld      b,(hl)
        inc     hl
        inc     hl
        ld      a,(hl)
        or      a
        jp      z,noSprite
        dec     hl

        ld      a,(hl)
        ld      l,a             ;sprid*4

;get_new_spr_addr:
        ld      h,0     
        add     hl,hl           ;sprid*8
        
        ld      a,b     
        and     7       
        or      l       
        ld      l,a             ;sprid*8+x
        add     hl,hl           ;*2
        ld      de,sprite_addr
        add     hl,de           ;spr spr addr

        ld      e,(hl)
        inc     hl
        ld      h,(hl)
        ld      l,e

        ld      (retspraddr+1),hl

        ;y*64+(x/8)+scrbase

        ld      a,c
        rrca
        rrca
        ld      e,a
        and     3fh
        ld      d,a

        ld      a,e
        and     0c0h
        ld      e,a             ;de=y*64

        ld      a,b
        rrca
        rrca
        rrca
        and     1fh
        or      e
        ld      e,a             ;de=y*64+(x/8)
        ld      hl,GZU_BASE
        add     hl,de           ;scraddr
retspraddr:
        ld      de,0            ;sprite addr
        scf
        ret


;spr00_data:     db      192,0,0,0
;spr01_data:     db      192,0,0,0
;spr02_data:     db      192,0,0,0
;spr03_data:     db      192,0,0,0
;spr04_data:     db      192,0,0,0
;spr05_data:     db      192,0,0,0
;spr06_data:     db      192,0,0,0
;spr07_data:     db      192,0,0,0
;spr08_data:     db      192,0,0,0
;spr09_data:     db      192,0,0,0
;spr10_data:     db      192,0,0,0
;spr11_data:     db      192,0,0,0
;spr12_data:     db      192,0,0,0
;spr13_data:     db      192,0,0,0
;spr14_data:     db      192,0,0,0
;spr15_data:     db      192,0,0,0
;spr16_data:     db      192,0,0,0
;spr17_data:     db      192,0,0,0
;spr18_data:     db      192,0,0,0
;spr19_data:     db      192,0,0,0
;spr20_data:     db      192,0,0,0
;spr21_data:     db      192,0,0,0
;spr22_data:     db      192,0,0,0
;spr23_data:     db      192,0,0,0
;spr24_data:     db      192,0,0,0
;spr25_data:     db      192,0,0,0
;spr26_data:     db      192,0,0,0
;spr27_data:     db      192,0,0,0
;spr28_data:     db      192,0,0,0
;spr29_data:     db      192,0,0,0
;spr30_data:     db      192,0,0,0
;spr31_data:     db      192,0,0,0
;spr32_data:     db      192,0,0,0


;spr00_data	EQU	_Sprite_00
;spr01_data	EQU	_Sprite_01
;spr02_data	EQU	_Sprite_02
;spr03_data	EQU	_Sprite_03
spr04_data	EQU	_Sprite_04_Hair
spr05_data	EQU	_Sprite_05_Face
spr06_data	EQU	_Sprite_06_Body
spr07_data	EQU	_Sprite_07_Foot
spr08_data	EQU	_Sprite_08_Shadow
spr09_data	EQU	_Sprite_09_BridgeLeft
spr10_data	EQU	_Sprite_10_BridgeRight
spr11_data	EQU	_Sprite_11_Fish1
spr12_data	EQU	_Sprite_12_Fish2
spr13_data	EQU	_Sprite_13_Fish3
spr14_data	EQU	_Sprite_14_Ball
spr15_data	EQU	_Sprite_15_Ball2
spr16_data	EQU	_Sprite_16_Falling1
spr17_data	EQU	_Sprite_17_Falling2
spr18_data	EQU	_Sprite_18_Falling3
spr19_data	EQU	_Sprite_19_Apple
spr20_data	EQU	_Sprite_20_Bee
spr21_data	EQU	_Sprite_21_BeeBlackStripes
spr22_data	EQU	_Sprite_22_Stone
spr23_data	EQU	_Sprite_23_Bonus1
;spr24_data	EQU	_Sprite_24
;spr25_data	EQU	_Sprite_25
;spr26_data	EQU	_Sprite_26
spr27_data	EQU	_Sprite_27_Life1
spr28_data	EQU	_Sprite_28_Life2
spr29_data	EQU	_Sprite_29_Life3
spr30_data	EQU	_Sprite_30_Life4
;spr31_data	EQU	_Sprite_31_FireVegetable??

SS1=$

        display /A,"SPROUTSIZE:",SS1-SS0
