
CopyToVRAM_HL_DE_BC:			
;		ld 	a,1
;		ld 	(RequireScreenUpdate),a

WrVRAMLoop_HLDEBC:
		ld	a, (hl)
		ld 	(de),a

;???????? required ???
		inc 	de
;???????? required ???

		inc	hl
		dec	bc
		ld	a, b
		or	c
		jp	nz, WrVRAMLoop_HLDEBC

		ld 	a,1
		ld 	(RequireScreenUpdate),a
		ret


Fill_VRAM_DE_A_BC:			; CODE XREF: ML_8_MenuBlink+4E j	ML_10_DelayBefore+11 p ...
		push 	de
		ld	h, a

		ld 	a,1
		ld 	(RequireScreenUpdate),a

L4569:					; CODE XREF: Fill_VRAM_DE_A_BC+F j
		ld	a, h

		ld 	(de),a
		inc	de		
		dec	bc
		ld	a, b
		or	c
		jp	nz, L4569
		pop 	de
		ret


;VDP_LDIR_DE_H_BC:			; CODE XREF: VDP_LDIR_DE_H_BC+D j
;					; CopyPGT1toPCT23+9 p ...
;		call	vdp_rd_de
;		ex	de, hl
;		call	vdp_wr_de_a
;		ex	de, hl
;		inc	hl
;		inc	de
;		dec	bc
;		ld	a, c
;		or	b
;		jp	nz, VDP_LDIR_DE_H_BC
;		ret


;Show message on screen
; FF - end of message
; FE - next two byte - new screen addr

xStringToVram_HL:
		ld 	a,1
		ld 	(RequireScreenUpdate),a
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl

xStringToVram_HLDE:			; CODE XREF: xStringToVram_HLDE+C j
		ld	a, (hl)
		inc	hl
		ld	b, a
		inc	b
		ret	z
		inc	b
		jp	z, xStringToVram_HL
;esl
;		call	vdp_wr_de_a
		ld 	(de),a
;esl
		inc	de
		jp	xStringToVram_HLDE

; =============== S U B	R O U T	I N E =======================================

;de screen addr
;a - first char
;c - len
; sample, a - 60, c - 3
; de: 60,61,62,63
;after exit - de point to next screen line de=strtde+32  

FillVRAM_NextLine:

		ld 	l,a
		ld 	a,1
		ld 	(RequireScreenUpdate),a
		ld 	a,l

		push	de
L4BA5:					; CODE XREF: FillVRAM_NextLine+6 j
;esl
;		call	vdp_wr_de_a
		ld 	(de),a
;esl
		inc	de
		inc	a
		
		;djnz
		dec b
		jp nz,L4BA5

		pop	de
		ld	hl, 32
		add	hl, de
		ex	de, hl

		ret
; End of function FillVRAM_NextLine


; =============== S U B	R O U T	I N E =======================================


UnpackRLE_Struct:			; CODE XREF: PrepareAthleticLand+3 p

		ld 	a,1
		ld 	(RequireScreenUpdate),a


		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl

UnpackRLE_ToVRAM:			; CODE XREF: PrepareAthleticLand+10 p
					; PrepareKonami+6 p
		;di
		;call	out_de_99

L4BBB:					; CODE XREF: UnpackRLE_ToVRAM+15 j
					; UnpackRLE_ToVRAM+1F j
		ld	a, (hl)
		inc	hl
		or	a
		ret	z
;ESL
;		bit	7, a
;		jp	nz, L4BCE
		jp	s, L4BCE
;ESL
		ld	b, a
		ld	a, (hl)
		inc	hl

L4BC6:					; CODE XREF: UnpackRLE_ToVRAM+13 j
;		out	(VDP_VRAM), a
;		nop
;		nop
		ld 	(de),a		
		;djnz
		dec b
		jp nz,L4BC6

		jp	L4BBB
; ---------------------------------------------------------------------------

L4BCE:					; CODE XREF: UnpackRLE_ToVRAM+A j
;		res	7, a 		;z80_vdp_utils
		and 	07fh

		ld	c, a
		ld	b, 0
		call	WrVRAMLoop_HLDEBC
		jp	L4BBB
; End of function UnpackRLE_ToVRAM

; =============== S U B	R O U T	I N E =======================================

;Unpack
;called as
;	;call Unpacker_5F65
;	dw 	control_stream
;	dw 	data_stream
;	dw 	screen_addr

; control stream
; 00h 		- stop
; 01..7Fh	- copy nn bytes from data stream to VRAM
; 80h 		- dw new_screen_addr
; 81..fFh	- fill nn & 7fh bytes with byte from data

Unpacker_5F65:
		ld 	a,1
		ld 	(RequireScreenUpdate),a

		pop	hl
		ld	de, xcp_CmdStream
		ld	bc, 6
	
		;ldir
		call	_LDIR_

		push	hl

xUnpackLoop:				; CODE XREF: Unpacker_5F65+5C j
		ld	hl, (xcp_CmdStream)
		ld	a, (hl)
		cp	80h ; '€'
		jp	nz, L5F84
		inc	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	(xcp_CmdStream), hl
;esl
;		ld	(xCP_VRAM), de
		ex 	hl,de
		ld	(xCP_VRAM), hl
		ex 	hl,de

		ld	a, (hl)

L5F84:					; CODE XREF: Unpacker_5F65+10 j
		or	a
		ret	z
		ld	b, a
		and	7Fh ; ''
		ld	c, a
;ESL
;		xor	a
;		bit	7, b
;		ld	b, a
		cp 	b
		ld 	b,0

;ESL

;esl
;		ld	hl, (xCP_DataStream)
;		ld	de, (xCP_VRAM)

		ld	hl, (xCP_VRAM)
		ex 	hl,de
		ld	hl, (xCP_DataStream)



		jp	z, L5F9F
		ld	a, (hl)
		call	Fill_VRAM_DE_A_BC
		ld	a, 1
		jp	FinishUnpackLoop
; ---------------------------------------------------------------------------

L5F9F:					; CODE XREF: Unpacker_5F65+30 j
		push	bc
		call	CopyToVRAM_HL_DE_BC
		pop	bc
		ld	a, c

FinishUnpackLoop:			; CODE XREF: Unpacker_5F65+38 j
		ld	hl, (xCP_DataStream)
		call	add_a_hl
		ld	(xCP_DataStream), hl
		ld	hl, (xcp_CmdStream)
		ld	a, (hl)
		and	7Fh ; ''
		inc	hl
		ld	(xcp_CmdStream), hl
		ld	hl, (xCP_VRAM)
		call	add_a_hl
		ld	(xCP_VRAM), hl
		jp	xUnpackLoop
; End of function Unpacker_5F65



; =============== S U B	R O U T	I N E =======================================

;Copy rectangle box to screen
;de - vram
;hl - pattern to copy
;b - row count
;c - columb


CopyToVRAM_ROW:
		ld 	a,1
		ld 	(RequireScreenUpdate),a

		push	bc
		push	de

L6413:					; CODE XREF: CopyToVRAM_ROW+9 j
		ld	a, (hl)
;esl
;		call	vdp_wr_de_a
		ld 	(de),a
;esl
		inc	hl
		inc	de
		dec	c
		jp	nz, L6413
		pop	de
		ld	a, 32
		call	add_a_de
		pop	bc
		
		;djnz
		dec b
		jp nz,CopyToVRAM_ROW

		ret
; End of function CopyToVRAM_ROW
