;SoundCH1:	ds 10			; DATA XREF: doSOUND+9 o RAM:436F r ...
;SoundCH2:	ds 10
;SoundCH3:	ds 10

_IX_:		ds 10

	macro CP10 _from_,_to_
		push 	hl
	 	ld 	hl,(_from_+0)
	 	ld 	(_to_+0),hl
	 	ld 	hl,(_from_+2)
	 	ld 	(_to_+2),hl
	 	ld 	hl,(_from_+4)
	 	ld 	(_to_+4),hl
	 	ld 	hl,(_from_+6)
	 	ld 	(_to_+6),hl
	 	ld 	hl,(_from_+8)
	 	ld 	(_to_+8),hl
		pop 	hl
	 	ret
	endm

ch1ix: 	CP10 	SoundCH1,_IX_
ch2ix: 	CP10 	SoundCH2,_IX_
ch3ix: 	CP10 	SoundCH3,_IX_

ix1ch: 	CP10 	_IX_,SoundCH1 
ix2ch: 	CP10 	_IX_,SoundCH2 
ix3ch: 	CP10 	_IX_,SoundCH3 

active_ch:
	db 	0


; ---------------------------------------------------------------------------

;L77F8:					; 0 1
;		ld	hl, g_Flags	; 1 2
;					; 2 4
;					; 3 8
;					; 4 1 -	0 - joy, 1 - KeyboardUserInput
;					; 5 2 -	0 one player,1 - 2 player
;					; 6 4 -	Game Flag (no demo)?
;					; 7 8 -	Activ Player?
;		bit	6, (hl) ;z80_never used routine
;		ret	z

; =============== S U B	R O U T	I N E =======================================


SelectMUSIC_A:				; CODE XREF: ML_8_MenuBlink+1D p	ML_9_BeforeStage+2A p ...
		ld 	(LAST_SOUND),a

		di
		push	de
		ld	d, 0
		call	SetMusic_A
		pop	de
		ei
		ret
; End of function SelectMUSIC_A

; ---------------------------------------------------------------------------

SetMusic_A:				; CODE XREF: SelectMUSIC_A+4 p
					; doSOUNDChennel-28 p
		ld	b, 2

		ld 	l,a
		ld 	a,(active_ch)
		or 	a
		jp 	z,sma_ch1
		dec 	a
		call 	z,ix1ch
		dec 	a
		call 	z,ix2ch
		dec 	a
		call 	z,ix3ch
sma_ch1:
		ld 	a,l


		ld	hl,  SoundCH1+2

		cp	8Eh ; ''
		jp	c, L7818
		cp	90h ; ''
		jp	c, L781C
		inc	b
		jp	L781C
; ---------------------------------------------------------------------------

L7818:					; CODE XREF: RAM:780F j
		dec	b

		ld	hl,  SoundCH3+2
L781C:					; CODE XREF: RAM:L7813 j RAM:7816 j
		dec	d
		jp	z, L782E
		cp	(hl)
		jp	z, L7851
		jp	c, L7851
		cp	95h ; ''
		jp	c, L782E
		cp	9Bh ; ''
		jp	nc, L782E
		and	7Fh ; ''

L782E:					; CODE XREF: RAM:781D j	RAM:7826 j ...
		ld	c, a
		and	3Fh ; '?'
		add	a, a
		ld	de, MusicTable	
		call	add_a_de

L7838:					; CODE XREF: RAM:784F j
		dec	hl
		dec	hl
		ld	(hl), 1
		inc	hl
		ld	(hl), 1
		inc	hl
		ld	a, c
		ld	(hl), a
		inc	hl
		ld	a, (de)
		ld	(hl), a
		inc	hl
		inc	de
		ld	a, (de)
		ld	(hl), a
		ld	a, 8
		call	add_a_hl
		inc	de
		
		;djnz
		dec b
		jp nz,L7838


L7851:					; CODE XREF: RAM:7820 j	RAM:7822 j


		ld 	l,a
		ld 	a,(active_ch)
		or 	a
		jp 	z,sma_ch2
		dec 	a
		call 	z,ch1ix
		dec 	a
		call 	z,ch2ix
		dec 	a
		call 	z,ch3ix
sma_ch2:
		ld 	a,l

		ret
; ---------------------------------------------------------------------------
; START	OF FUNCTION CHUNK FOR doSOUNDChennel

_SetSound2:				; CODE XREF: doSOUNDChennel+10 j
		ld	a, (_IX_+2) 	;z80_sound
		push	bc
		ld	d, 1
		call	SetMusic_A
		pop	bc
		ret
; END OF FUNCTION CHUNK	FOR doSOUNDChennel

; =============== S U B	R O U T	I N E =======================================


; interrupt routine

doSOUND0:				; CODE XREF: RAM:4041 p
		ld	b, 3
		ld	de, 10
		push	bc
		push	de
		ld	l, 1
		ld	ix, SoundCH1 	;z80_sound
		jp	L786E

L786C:					; CODE XREF: doSOUND+20 j
		push	bc
		push	de

L786E:					; CODE XREF: doSOUND+D j
		ld	c, l
		ld	a, (_IX_+2) 	;z80_sound
		or	a
		call	nz, doSOUNDChennel
		inc	c
		inc	c
		ld	l, c
		pop	de
		pop	bc
		add	ix, de 	;z80_sound
		
		;djnz
		dec b
		jp nz,L786C

		ret
; End of function doSOUND


doSOUND1:

		ld 	a,0
		ld 	(active_ch),a

		ld	c, 1
		ld	a, (SoundCH1+2) 	;z80_sound
		or	a
		jp 	z,doSOUND2

		push	af
		ld 	a,1
		ld 	(active_ch),a
		pop	af

		call 	ch1ix
		call	doSOUNDChennel
		call 	ix1ch
;		jp 	doSOUND4
;		jp 	doSOUND3

doSOUND2:
		ld	c, 3

		ld	a, (SoundCH2+2) 	;z80_sound
		or	a
		jp 	z,doSOUND3

		push	af
		ld 	a,2
		ld 	(active_ch),a
		pop	af

		call 	ch2ix
		call	doSOUNDChennel
		call 	ix2ch
;		jp 	doSOUND4

doSOUND3:

		ld	c, 5

		ld	a, (SoundCH3+2) 	;z80_sound
		or	a
		jp 	z,doSOUND4

		push	af
		ld 	a,3
		ld 	(active_ch),a
		pop	af

		call 	ch3ix
		call	doSOUNDChennel
		call 	ix3ch
;		jp 	doSOUND4

doSOUND4:
		ld 	a,0
		ld 	(active_ch),a
		ret


; =============== S U B	R O U T	I N E =======================================


doSOUNDChennel:				; CODE XREF: doSOUND+16 p

; FUNCTION CHUNK AT 7852 SIZE 0000000B BYTES
; FUNCTION CHUNK AT 7902 SIZE 0000004F BYTES

		jp	m, L78D7
;esl
;		dec	(_IX_+0) 		;z80_sound
		ld 	a,(_IX_+0)
		dec 	a
		ld 	(_IX_+0),a
;esl
		ret	nz

L7887:					; CODE XREF: L78C2+18 j
;esl
;		ld	l, (_IX_+3)	;z80_sound
;		ld	h, (_IX_+4)	;z80_sound
		ld 	hl,(_IX_+3)
;esl

		ld	a, (hl)
		cp	0FEh ; ''
		jp	z, _SetSound2
		jp	nc, L78D0
;ESL
;		bit	7, (_IX_+2)	;z80_sound
		ld 	a,(_IX_+2)
		and 	1<<7
		ld	a, (hl)
;esl
		jp	nz, L7902
		and	0F0h ; ''
		cp	20h ; ' '
		jp	nz, L78A8
		ld	a, (hl)
		and	0Fh
		ld	(_IX_+1),	a 	;z80_sound
		inc	hl

L78A8:					; CODE XREF: doSOUNDChennel+1F j
		ld	a, (hl)
		and	0F0h ; ''
		ld	b, a
		xor	(hl)
		ld	d, a
		inc	hl
		ld	e, (hl)
		inc	hl
;esl
;		ld	(_IX_+3),	l 	;z80_sound
;		ld	(_IX_+4),	h 	;z80_sound
		ld 	(_IX_+3),hl
;esl
		ex	de, hl
		call	PSG_RegPair_C_HL
		ld	a, b
		rrca
		rrca
		rrca
		rrca
		and	0Fh
L78C2:					; CODE XREF: doSOUNDChennel:L793A p
		ld	h, a
		ld	a, (_IX_+1) 	;z80_sound
		ld	(_IX_+0),	a 	;z80_sound
		add	a, 3
		ld	(_IX_+8),	a 	;z80_sound
		jp	L78F8
; ---------------------------------------------------------------------------

L78D0:					; CODE XREF: doSOUNDChennel+12 j
		xor	a
		ld	(_IX_+2),	a 	;z80_sound
		ld	h, a
		jp	L78F8
; ---------------------------------------------------------------------------

L78D7:					; CODE XREF: doSOUNDChennel j
;esl
;		dec	(_IX_+0) 		;z80_sound
		ld 	a,(_IX_+0)
		dec 	a
		ld 	(_IX_+0),a
;esl
		jp	z, L7887
;esl
;		dec	(_IX_+8) 		;z80_sound
		ld 	a,(_IX_+8)
		dec 	a
		ld 	(_IX_+8),a
;esl



;esl
;		ld	a, (_IX_+8) 	;z80_sound
;		cp	(_IX_+0) 		;z80_sound
		ld 	a,(_IX_+0)
		ld 	h,a
		ld	a, (_IX_+8) 	;z80_sound
		cp 	h
;esl
		jp	nz, L78EC
		cp	3
		jp	c, L78EF
		ret
; ---------------------------------------------------------------------------

L78EC:					; CODE XREF: L78C2+23 j
;esl
;		dec	(_IX_+8) 		;z80_sound
		ld 	a,(_IX_+8)
		dec 	a
		ld 	(_IX_+8),a
;esl


L78EF:					; CODE XREF: L78C2+27 j
		ld	a, (_IX_+7) 	;z80_sound
		dec	a
		ret	m
		ld	(_IX_+7),	a 	;z80_sound
		ld	h, a

L78F8:					; CODE XREF: L78C2+C j L78C2+13 j
		ld	a, c
		rrca
		add	a, 88h ; ''
;		out	(PSG_RegisterWrite), a
;		ld	a, h
;		out	(PSG_ValueWrite), a


		push 	de
		;ld 	a,c
		ld 	e,h

		call 	WRTPSG	;a-reg, e-value
		pop	de

		ret
; End of function L78C2

; ---------------------------------------------------------------------------
; START	OF FUNCTION CHUNK FOR doSOUNDChennel

L7902:					; CODE XREF: doSOUNDChennel+18 j
		cp	0FDh ; ''
		jp	nz, L7916
		inc	hl
		ld	a, (hl)
		and	7
		ld	(_IX_+5),	a 	;z80_sound
		xor	(hl)
		rrca
		rrca
		rrca
		ld	(_IX_+6),	a 	;z80_sound
		inc	hl
		ld	a, (hl)

L7916:					; CODE XREF: doSOUNDChennel+84 j
		and	0Fh
		ld	b, a
		xor	(hl)
		inc	hl
;esl
;		ld	(_IX_+3),	l 	;z80_sound
;		ld	(_IX_+4),	h 	;z80_sound
		ld 	(_IX_+3),hl
;esl
		rrca
		rrca
		rrca
		rrca
		ld	hl, L79AE
		call	add_a_hl
		ld	a, (hl)
		ld	(_IX_+1),	a 	;z80_sound
		ld	a, b
		sub	0Ch
		jp	z, L793A
		ld	a, (_IX_+6) 	;z80_sound
		ld	(_IX_+7),	a 	;z80_sound

L793A:					; CODE XREF: doSOUNDChennel+B2 j
		call	L78C2
		ld	a, b
		ld	hl, L7960
		call	add_a_hl
		ld	l, (hl)
		ld	h, 0
		ld	a, (_IX_+5) 	;z80_sound
		or	a
		jp	z, PSG_RegPair_C_HL
		ld	b, a

L794E:					; CODE XREF: doSOUNDChennel+CF j
		add	hl, hl
		
		;djnz
		dec b
		jp nz,L794E

; END OF FUNCTION CHUNK	FOR doSOUNDChennel

; =============== S U B	R O U T	I N E =======================================


PSG_RegPair_C_HL:			; CODE XREF: doSOUNDChennel+38 p
					; doSOUNDChennel+CB j
;		ld	a, c
;		out	(PSG_RegisterWrite), a
;		ld	a, h
;		out	(PSG_ValueWrite), a
		push	de

		ld 	a,c
		ld 	e,h

		call 	WRTPSG	;a-reg, e-value

		dec	c

;		ld	a, c
;		out	(PSG_RegisterWrite), a
;		ld	a, l
;		out	(PSG_ValueWrite), a

		ld 	a,c
		ld 	e,l

		call 	WRTPSG	;a-reg, e-value

		inc	c
		pop	de
		ret
; End of function PSG_RegPair_C_HL


; ---------------------------------------------------------------------------
L7960:		db  6Ah, 64h, 5Fh, 59h,	54h, 50h, 4Bh, 47h, 43h, 3Fh, 3ch, 38h ; DATA XREF:	doSOUNDChennel+BE o
;		db 383Ch	

L79AE:		db    5, 0Ah, 0Fh,   6,	0Ch, 18h, 28h, 48h,  4,    8, 10h, 20h,	14h, 42h ; DATA XREF:	doSOUNDChennel+A5 o

; enum musicID
;mClickScorePoint	EQU	1
;mPlayerStep	EQU	2
;mJump	EQU	3
;m04_Bomba?	EQU	4
;m05_tone	EQU	5
;mSilenceFade???	EQU	6
;mFishJump	EQU	7
;mBallBounce	EQU	8
;m09_Batut	EQU	9
;m0A_Bonus	EQU	0Ah
;m0b_tu	EQU	0Bh
;m0C_IncLife	EQU	0Ch
;mTimeOut	EQU	0Dh
;mMainMusic	EQU	8Eh
;mKill	EQU	90h
;mGameOver	EQU	93h
;m96_Dead?	EQU	96h
;m99_killWater	EQU	99h
;mLevelStartStageEnd	EQU	9Ch
;mGameStart	EQU	9Dh

MusicTable2:
		dw _m01_ClickScorePoint	; 1 ; TwoFirstByte from	prev table
		dw _m02_Player_Step	; 2
		dw _m03_Jump		; 3
		dw _m04_bomba		; 4
		dw _m05_tone		; 5
		dw _m06_noSound		; 6
		dw _m07_FishJump	; 7
		dw _m08_BallBounce	; 8
		dw _m09_batut		; 9
		dw _m0A_Bonus		; 0Ah
		dw _m0B_tu		; 0Bh
		dw _m0C_inc_life	; 0Ch
		dw _m0D_TImeOut		; 0Dh
		dw _m06_noSound		; 
;		dw _m0E_MainTheme	; 0Eh
		dw _M0F			; 0Fh
		dw _m10_Kill		; 10h
		dw _M11			; 11h
		dw _m06_noSound		; 12h
		dw _M13_GameOver	; 13h
		dw _M14			; 14h
		dw _M15			; 15h
		dw _M16_dead?		; 16h
		dw _m06_noSound		; 17h
		dw _m06_noSound		; 18h
		dw _M19_killWater	; 19h
		dw _m06_noSound		; 1Ah
		dw _m06_noSound		; 1Bh
		dw _m06_noSound		; 
;		dw _M1C_levelStartStageEnd; 1Ch
		dw _M1D_GameStart	; 1Dh
		dw _m06_noSound		; 
;		dw _M1E			; 1Eh
		dw _m06_noSound		; 1Fh
		dw _m06_noSound		; 20h
		dw _m06_noSound		; 21h


MusicTable 	equ	MusicTable2-2


_M1C_levelStartStageEnd:
		db 0FDh, 5Ah, 45h, 35h,	35h, 45h, 35h, 35h
		db  49h,0FDh, 59h, 30h,	30h,0FDh, 5Ah, 39h
		db  39h, 45h,0FDh, 59h,	40h,0FDh, 5Ah, 3Ah
		db  3Ah, 39h, 39h, 37h,	37h, 55h, 55h

_m06_noSound:	
		db 0FFh			

_M1D_GameStart:	
		db 0FDh, 5Bh, 45h, 49h,	45h, 49h, 45h, 49h 
		db  45h, 49h, 44h, 47h,	50h, 45h, 40h, 5Ch
		db 0FFh

_M1E:	db 0FDh, 59h, 4Ch, 40h,	4Ch, 40h, 4Ch, 40h 
		db  4Ch, 40h, 4Ch, 40h,	5Ch, 5Ch,0FDh, 5Ah
		db  55h,0FFh

_m0E_MainTheme:	
		db 0FDh, 5Ah, 1Ch, 14h,	1Ch, 17h,0FDh, 59h 
		db  20h,   2, 10h,0FDh,	5Ah, 17h, 1Ch, 14h
		db  1Ch, 17h,0FDh, 59h,	60h,0FDh, 5Ah, 1Ch
		db  15h, 1Ch, 19h,0FDh,	59h, 22h,   4, 12h
		db 0FDh, 5Ah, 19h, 1Ch,	15h, 1Ch, 19h,0FDh
		db  59h, 62h,0FDh, 5Ah,	1Ch, 14h, 1Ch, 17h
		db 0FDh, 59h, 20h,   2,	10h,0FDh, 5Ah, 17h
		db  1Ch, 14h, 1Ch, 17h,0FDh, 59h, 60h,0FDh
		db  5Ah, 1Ch, 15h, 1Ch,	19h,0FDh, 59h, 22h
		db    4, 12h,0FDh, 5Ah,	19h, 1Ch, 15h, 1Ch
		db  19h,0FDh, 59h, 24h,	  2,0FDh, 5Ah, 19h
		db  15h,0FEh

_M0F:	db 0FDh, 5Bh, 10h, 17h,0FDh, 5Ch, 1Bh,0FDh 
		db  5Bh, 17h,0FDh, 5Ch,	19h,0FDh, 5Bh, 17h
		db 0FDh, 5Ch, 1Bh,0FDh,	5Bh, 17h, 10h, 17h
		db 0FDh, 5Ch, 1Bh,0FDh,	5Bh, 17h,0FDh, 5Ch
		db  19h,0FDh, 5Bh, 17h,0FDh, 5Ch, 17h,0FDh
		db  5Bh, 17h, 12h, 19h,	11h, 19h, 10h, 19h
		db  11h, 19h, 12h, 19h,	11h, 19h, 10h, 19h
		db 0FDh, 5Ch, 1Bh,0FDh,	5Bh, 17h, 10h, 17h
		db 0FDh, 5Ch, 1Bh,0FDh,	5Bh, 17h,0FDh, 5Ch
		db  19h,0FDh, 5Bh, 17h,0FDh, 5Ch, 1Bh,0FDh
		db  5Bh, 17h, 10h, 17h,0FDh, 5Ch, 1Bh,0FDh
		db  5Bh, 17h,0FDh, 5Ch,	19h,0FDh, 5Bh, 17h
		db 0FDh, 5Ch, 17h,0FDh,	5Bh, 17h, 12h, 19h
		db  11h, 19h, 10h, 19h,	11h, 19h, 12h, 19h
		db  11h, 19h, 10h, 19h,0FDh, 5Ch, 1Bh,0FDh
		db  5Bh, 17h,0FEh

_M13_GameOver:	
		db 0FDh, 59h,0C2h, 21h,0C4h,0C2h,   1,0C1h 
		db 0FDh, 5Ah, 2Bh,0FDh,	59h,0C2h,0C1h,0FDh
		db  5Ah, 0Bh, 2Bh, 0Ah,	2Bh,0FDh, 59h,	 2
		db 0C1h,0FDh, 5Ah, 29h,0FDh, 59h,0D2h,0FFh

_M14:	
		db 0FDh, 5Ah,0C6h, 26h,0C6h,0C6h,   6,0C6h 
		db  26h,0C6h,0C6h,   6,	27h,   6, 27h, 0Bh
		db 0C9h, 27h,0D6h,0FFh

_M15:	
		db 0FDh, 5Bh,0C2h,0C9h,0C2h,0C9h,0FDh, 54h 
		db 0CBh,0FDh, 53h,0C6h,0FDh, 54h,0CBh,0FDh
		db  53h,0C6h,0C7h, 27h,	  8,0C9h, 29h,0C2h
		db    8, 19h,0FDh, 52h,	11h, 12h,0FDh, 53h
		db  12h,0FFh

_m03_Jump:	
		db  22h,0D0h, 8Fh,0B0h,	80h,0B0h, 87h,0A0h 
		db  72h, 90h, 60h, 80h,	53h,0FFh

_m09_batut:	
		db  22h,0C1h, 77h,0B1h,	55h,0A1h, 77h, 91h 
		db  55h, 81h, 77h, 71h,	50h, 61h, 77h, 51h
		db  50h, 41h, 77h, 31h,	50h,0FFh

_m08_BallBounce:
		db  21h,0C2h, 11h,0C2h,	  0,0C2h, 11h,0C2h 
		db    0,0A2h, 11h, 92h,	  0, 82h, 11h, 72h
		db    0, 23h, 62h, 11h,	52h,   0, 52h, 11h
		db  42h,   0, 42h, 11h,	42h,   0, 32h, 11h
		db 0FFh

_m07_FishJump:	
		db  21h,0B0h,0AAh,0B0h,	77h,0B0h, 88h,0B0h 
		db  55h,0B0h, 66h,0B0h,	33h,0B0h, 44h,0B0h
		db  22h,0FFh

_m02_Player_Step:
		db  21h,0B0h, 90h,0B0h,0A0h, 28h,   0,	  0 
		db  21h,0B0h, 70h,0B0h,	80h,0FFh

_M19_killWater:	
		db  23h,0C1h, 27h,0C1h,	9Ah,0C1h,0C4h,0C2h 
		db  12h,0C2h,	6,0C2h,0F7h,0C3h,0C3h, 50h
		db 0A3h,0CFh, 84h, 30h,	64h,0B5h, 26h, 45h
		db  31h,0FFh

_M16_dead?:	
		db  22h,0C2h,	5,0C2h,	0Eh,0C3h, 22h,0C2h 
		db 0CCh,0C2h,0FBh,0FFh

_m01_ClickScorePoint:
		db  21h,0B0h, 38h,0A0h, 38h,0B0h, 48h,0A0h,  48h,0FFh

_m05_tone:	
		db  21h, 92h,	0, 91h,0F5h,0FEh 

_m04_bomba:	
		db  21h,0D1h, 99h,0C1h,	99h,0D1h, 99h,	 0 
		db    0, 22h,0C0h, 90h,0B0h, 80h,0A0h, 70h
		db  90h, 60h, 80h, 50h,	70h, 4Ch, 60h, 48h
		db  50h, 44h, 40h, 40h,0FFh

_m10_Kill:	
		db 0FDh, 62h, 40h, 84h,	97h, 94h, 42h, 85h 
		db  99h, 95h, 44h, 87h,	9Bh, 97h,0FDh, 61h
		db  50h,0FFh

_M11:	db 0FDh, 63h,0B4h,0B5h,0B7h, 50h,0FFh 

_m0B_tu:
		db  21h,0B1h, 50h,0B1h,	60h,0B1h, 50h, 25h,  0,   0,0FFh

_m0C_inc_life:	
		db  24h,0C1h, 1Dh,0C0h,0D5h,0C0h,0A9h,0C0h 
		db  8Eh,0C1h, 1Dh,0C0h,0D5h,0C0h,0A9h,0C0h
		db  8Eh,0FFh

_m0D_TImeOut:	
		db  23h, 90h, 60h, 90h,	40h, 90h, 60h, 90h 
		db  40h, 90h, 60h, 90h,	40h, 90h, 60h, 90h
		db  40h, 90h, 60h, 90h,	40h, 90h, 60h,0FFh

_m0A_Bonus:	
		db  22h,0D0h,0A9h,0D0h,	8Eh,0D0h, 6Ah,0D0h 
		db 0A9h,0D0h, 8Eh,0D0h,	6Ah,0FFh

