; UpdateHiScore - part of DispalyMessages routine

; =============== S U B	R O U T	I N E =======================================

AddBonus_DE:				; CODE XREF: RAM:4384 p	doBonus+1E p
		ld	a, mClickScorePoint
		call	SelectMUSIC_A

AddBonus_DE_NoClick:			; CODE XREF: ML_9_BeforeStage+3D p
		ld	a, (g_Flags)	; 0 1
					; 1 2
					; 2 4
					; 3 8
					; 4 1 -	0 - joy, 1 - KeyboardUserInput
					; 5 2 -	0 one player,1 - 2 player
					; 6 4 -	Game Flag (no demo)?
					; 7 8 -	Activ Player?
		add	a, a
		ret	p
;
		ld	hl,  g_HIScore+1
		jp	nc, L4654
		ld	l, 46h ; 'F'    ; !PATCH HERE, used only LO byte of addr

L4654:					; CODE XREF: AddBonus_DE+D j
		ld	a, (hl)
		add	a, e
		daa
		ld	(hl), a
;
		ld	e, a
		inc	l
		ld	a, (hl)
		adc	a, d
		daa
		ld	(hl), a
;
		ld	d, a
		jp	nc, L4676
		inc	hl
;
		ld	a, (hl)
		adc	a, 0
		daa
		ld	(hl), a
;
		jp	nc, L4677
;
;		ld	bc, 9999h
;		ld	(unk_E040), bc
;		ld	(unk_E041), bc

		ld	hl, 9999h
		ld	(unk_E040), hl
		ld	(unk_E041), hl

		jp	UpdateHiScore	;first cmd: ld      hl, g_HIScore
; ---------------------------------------------------------------------------

L4676:					; CODE XREF: AddBonus_DE+1C j
		inc	hl

L4677:					; CODE XREF: AddBonus_DE+24 j
		ld	a, (gStage+1)
		cp	(hl)
		push	de
		push	hl
		jp	nc, L4695
		add	a, 2
		daa
		jp	nc, L4686
		ld	a, 0FFh

L4686:					; CODE XREF: AddBonus_DE+3F j
		ld	(gStage+1), a
		ld	hl, _Player1Data_LIFE
		inc	(hl)
		call	DisplayLIFE
		ld	a, m0C_IncLife
		call	SelectMUSIC_A

L4695:					; CODE XREF: AddBonus_DE+3A j
		pop	hl
		ld	a, (g_HIScore)
		ld	b, (hl)
		sub	(hl)
		ex	de, hl
		pop	de
		jp	c, L46AA
		jp	nz, L46EA
		push	hl
		ld	hl, (unk_E040)
;esl
;		sbc	hl, de
		call sbchlde
;esl
		pop	hl
		jp	nc, L46EA

L46AA:					; CODE XREF: AddBonus_DE+5A j

;		ld	(unk_E040), de
		ex 	de,hl
		ld	(unk_E040), hl
		ex 	de,hl

		ld	a, b
		ld	(g_HIScore), a
		jp	UpdateHiScore		;first cmd: ld      hl, g_HIScore
; End of function AddBonus_DE


; =============== S U B	R O U T	I N E =======================================


CheckBonuses_HL_Table:			; CODE XREF: _do_player_move+9C p	L67B6+25 p ...
		ld	a, (Xpos_Player_StartPos)
		cp	8
		jp	nz, _chk_bonus_RtoL

L662A:					; CODE XREF: CheckBonuses_HL_Table+10 j
		ld	a, (PlayerXPos)
		cp	(hl)
		call	nc, doBonus	; C - item num
		inc	c
		inc	hl
		
		;djnz
		dec b
		jp nz,L662A

		ret

_chk_bonus_RtoL:				; CODE XREF: CheckBonuses_HL_Table+5 j
					; CheckBonuses_HL_Table+1C j
		ld	a, (PlayerXPos)
		cp	(hl)
		call	c, doBonus	; C - item num
		inc	c
		inc	hl
		
		;djnz
		dec b
		jp nz,_chk_bonus_RtoL

		ret
; End of function CheckBonuses_HL_Table


; =============== S U B	R O U T	I N E =======================================

; C - item num

doBonus:				; CODE XREF: CheckBonuses_HL_Table+B p
					; CheckBonuses_HL_Table+17 p ...
		push	hl
		push	bc
		ld		a, c
		ld		hl, BonusTable
		call	add_a_hl
		ld		a, (hl)
		or		a
		jp		z, noBonuse
;
		ld		e, 0
		ld		(hl), e		; Clean	Bonuse,	use only once
;
;esl
;		rra			; mul bonuses to 10 (BCD)
;					; 05 ->	0050
;					; 10 ->	0100
;					; 20 ->	0200
;		rr		e
;		rra
;		rr		e
;		rra
;		rr		e
;		rra
;		rr		e
;

		ld 	d,a
		rla
		rla
		rla
		rla
		and 	0F0h
		ld  	e,a

		ld  	a,d
		rra
		rra
		rra
		rra
		and 	0fh

;esl

;
		ld		d, a
;
		push	de
		call	AddBonus_DE
		pop		de
;
		ld	b, 4
		ld	c, 0
		ld	hl, byte_E181

L666B:					; CODE XREF: doBonus+2F j
		ld	a, (hl)
		or	a
		jp	z, L6673
		inc	c
		inc	hl
		
		;djnz
		dec b
		jp nz,L666B


L6673:					; CODE XREF: doBonus+2B j
		push	hl

		ld	a, c
		add	a, a
		add	a, a
		ld	hl, _Sprite_23_Bonus1
		call	add_a_hl

		ld	bc, PlayerYPos
		ld	a, (bc)
		sub	10h
		ld	(hl), a 		;Y

		inc	hl
		inc	bc
		ld	a, (bc)
		ld	(hl), a 		;X

		inc	hl
		ld	a, d
		add	a, a
		add	a, a
		add	a, SPR_Score50
		ld	(hl), a 		;sprID

		inc	hl
		ld	(hl), 0Fh 		;COLOR


		ld	a, 1Eh
		pop	hl
		ld	(hl), a

noBonuse:				; CODE XREF: doBonus+B j
		pop	bc
		pop	hl
		ret
; End of function doBonus


