_MainGameLoop:				; CODE XREF: RAM:4056 p


;ESL_Korvet
		IFDEF _ESL_DEBUG
		call esl_debug
   		ENDIF

		ld 	a,M_SCR2_ALL
        	ld      (scr2_pnt_mode),a
;ESL_Korvet
        	
		ld	hl, inGameTick
		inc	(hl)
		
		ld	a, (g_Flags)	; 0 1
					; 1 2
					; 2 4
					; 3 8
					; 4 1 -	0 - joy, 1 - KeyboardUserInput
					; 5 2 -	0 one player,1 - 2 player
					; 6 4 -	Game Flag (no demo)?
					; 7 8 -	Activ Player?
		and	40h ; '@'
		call	nz, ShowPlayerID


;
		ld	a, (MainLoopStepCounter)
		ld	c, a
		cp	18
		jp	nc, L4142
		cp	8			; Check	Game Start only	if Step	<8 or >18
		jp	nc, L4145

L4142:					; CODE XREF: RAM:413C j
		call	CheckGameStartKeys ; Digits ROW

L4145:					; CODE XREF: RAM:4140 j
		ld	a, c
		call	jp_CASE_A
; ---------------------------------------------------------------------------
		dw ML_0_MainLoopNoop
		dw ML_1_PrepareKonami
		dw ML_2_KonamiScrollUP
		dw ML_3_PrepareAthleticLand
		dw ML_4_AthleticLandAnim
		dw ML_5_Delay_BeforeDemo
		dw ML_6_DemoStartClearScreenPrepareLevel
		dw ML_7_DemoLoop
		dw ML_8_MenuBlink
		dw ML_9_BeforeStage
		dw ML_10_DelayBefore
		dw ML_11_inGame
		dw ML_12_PlayerDead
		dw ML_13_SwapPlayers
		dw ML_14_
		dw ML_15_
		dw ML_16_18_NewScene
		dw ML_17_
		dw ML_16_18_NewScene
		dw ML_19_
; ---------------------------------------------------------------------------

ML_0_MainLoopNoop:			; DATA XREF: RAM:4149 o
		jp	MainLoopNEXT

; =============== S U B	R O U T	I N E =======================================

		include "_ml_0102_konami.asm"
		include "_ml_0304_AthleticLand.asm"
		include "_ml_050607_demo.asm"

		include "_ml_08_MenuBlink.asm"
		include "_ml_09_BeforeStage.asm"
		include "_ml_10_delayBefore.asm"
		include "_ml_11_inGame.asm"
		include "_ml_12_PlayerDeath.asm"
		include "_ml_13_swapplayers.asm"
		include "_ml_14.asm"
		include "_ml_15.asm"
		include "_ml_16x18_newScene.asm"
		include "_ml_17.asm"
		include "_ml_19.asm"

		include "_ml_utils.asm"


