; =============== S U B	R O U T	I N E =======================================


ML_3_PrepareAthleticLand:		; DATA XREF: RAM:414F o
		ld	hl, _ml_delay
		dec	(hl)
		ret	nz

		call	PrepareAthleticLand
		jp	MainLoopNEXT

ML_4_AthleticLandAnim:			; DATA XREF: RAM:4151 o
		ld	a, 0FFh
		ld	(byte_E00F), a
		call	TickShowAthleticLand ; Each tick show next row in Athletic Land	animatio
		ret	c

		ld	hl, xPlaySelect
		call	xStringToVram_HL
		
		xor	a
		jp	MinaLoopNext_DeayAA
; End of function ML_4_AthleticLandAnim


AthleticAnimation_AndMenu:		; CODE XREF: ML_8_MenuBlink+18 p	ML_8_MenuBlink+32 j ...
		call	TickShowAthleticLand ; Each tick show next row in Athletic Land	animatio
		jp	c, AthleticAnimation_AndMenu
		
		xor	a
		ld	(_TickDelay), a

		ld	hl, xPlaySelect
		jp	xStringToVram_HL
; ---------------------------------------------------------------------------

; =============== S U B	R O U T	I N E =======================================

; Each tick show next row in Athletic Land animatio
TickShowAthleticLand:			; CODE XREF: ML_4_AthleticLandAnim+5 p
					; ML_8_MenuBlink:AthleticAnimation_AndMenu p
		ld	hl, _TickDelay
		ld	a, (hl)
		inc	(hl)
		cp	17
		jp	nc, _ShowKonami84
;
		ld	de,  VLINE+(4*32)+8
		ld	c, a
		add	a, e
		ld	e, a		; (xy) 8,4 -> 8+n,4
;
		ld	a, c
		add	a, a
		add	a, 80h; 	;moved to 80h for one PNT ;40h ; '@'
		ld	c, a		; c=n*2+0x40
;
		ld	b, 3
		xor	a		; Clear	first line and fill two	next with char

_ClearLine:				; CODE XREF: TickShowAthleticLand+21 j
;esl
;		call	vdp_wr_de_a
		ld 	(de),a

		ld	a, 32
		call	add_a_de
		ld	a, c
		inc	c
		
		;djnz
		dec b
		jp nz,_ClearLine

		scf
		ret
; ---------------------------------------------------------------------------

_ShowKonami84:				; CODE XREF: TickShowAthleticLand+7 j
		push	af
		ld	hl, xConamy1984
		call	xStringToVram_HL
		pop	af
		cp	52				; time delay after (c) Konami 1984
		ret

xPlaySelect:	dw VLINE+(13*32)+11		; DATA XREF: ML_4_AthleticLandAnim+9 o
					; ML_8_MenuBlink+5E o
		db 'P','L','A','Y',  0,'S','E','L','E','C','T'
		db 0FEh
		dw VLINE+(16*32)+4
		db '1','@',5ch,5dh,  0,'1','P','L','A','Y','E','R',  0,  0,'^','_',  0,'J','O','Y','S','T','I','C','K'
		db 0FEh
		dw VLINE+(18*32)+4
		db '2','@',5ch,5dh,  0,'2','P','L','A','Y','E','R','S',  0,'^','_',  0,'J','O','Y','S','T','I','C','K'
		db 0FEh
		dw VLINE+(20*32)+4
		db '3','@',5ch,5dh,  0,'1','P','L','A','Y','E','R',  0,  0,'^','_',  0,'K','E','Y','B','O','A','R','D'
		db 0FEh
		dw VLINE+(22*32)+4
		db '4','@',5ch,5dh,  0,'2','P','L','A','Y','E','R','S',  0,'^','_',  0,'K','E','Y','B','O','A','R','D'
		db 0FFh


xConamy1984:	
;ESL_KORVET
;		dw VLINE+(8*32)+11		; DATA XREF: TickShowAthleticLand+26 o
		dw VLINE+(8*32)+11-5		; DATA XREF: TickShowAthleticLand+26 o
;ESL_KORVET
xConamy1984_2:	
;		db ':',';','<','=','>','?',  0,'1','9','8','4'
		db ':',';','<','=','>','?',  0,'1','9','8','4'
;ESL_KORVET
		db 0,'ESL',0,'2012'
;ESL_KORVET
		db 0FFh
