
	macro	m_sprite_process 	_spr_data_addr_,_erase_addr_ 	

        ;стераем спрайт
        ;ld     hl,0000         ;addr_to_erase
;        db      21h
;_erase_addr_:
;        dw      0000            ;addr_to_erase
;        call    sprite_erase

	ld	hl,_spr_data_addr_
	ld 	a,(hl)

	;cp	192
	;jp	nc,._no_update_requierd

._y_:
	cp	0ffh	;y
	jp	nz,._update_sprite3
	inc	hl

	ld 	a,(hl)
._x_:
	cp	0ffh	;x
	jp	nz,._update_sprite2
	inc	hl

	ld 	a,(hl)
._sprid_:
	cp	0ffh	;sprid
	jp	nz,._update_sprite1
	inc	hl

	ld 	a,(hl)
._color_:
	cp	0ffh	;color
	jp	nz,._update_sprite0
	jp	._no_update_requierd

._update_sprite3:
	inc	hl
._update_sprite2:
	inc	hl
._update_sprite1:
	inc	hl
._update_sprite0:
	ld 	a,(hl)
	ld 	(._color_+1),a
	dec	hl
	ld 	a,(hl)
	ld 	(._sprid_+1),a
	dec	hl
	ld 	a,(hl)
	ld 	(._x_+1),a
	dec	hl
	ld 	a,(hl)
	ld 	(._y_+1),a


        ;       db y,x,sprid,color
        ;de - sprptr
        ;hl - scraddr

        ;GetSpriteAddr:

        call    sprite_get_addr
        ld      (_erase_addr_),hl
        ex      hl,de
        ld      (.sprite_addr+1),hl
        ex      de,hl
        jp      .new_sprite

._no_update_requierd:
.sprite_addr:
        ld      de,0
        ld      hl,(_erase_addr_)

.new_sprite:
        call	sprite_show


	endm


	macro	m_sprite_erase _erase_addr_

	;ld 	hl,(_erase_addr_)
        db      21h
_erase_addr_:
        dw      0000            ;addr_to_erase

        ;no erase if hl=0

        ld      a,l
        or      h
        jp      z,.noerase
        call    sprite_erase
;       call    nz,sprite_erase
.noerase:
	endm
SS0=$

process_sprite:
        ;di

.waitVBL:
        ld      a,(0fb38h)
        and     2
        jp      nz,.waitVBL

        call    process_sprite_erase


        ld      a, 6Ch
        ld      (regbase1C+SYSREG), a

        xor     a
        ld      (sprite_show__cntr),a

        xor     a
        ld      (sprite_erase__cntr),a

;apple
        m_sprite_process spr19_data,spr19_erase
;falling
        m_sprite_process spr16_data,spr16_erase
        m_sprite_process spr17_data,spr17_erase
        m_sprite_process spr18_data,spr18_erase

;        m_sprite_process spr04_data,spr04_erase
        m_sprite_process spr05_data,spr05_erase
        m_sprite_process spr06_data,spr06_erase
;        m_sprite_process spr07_data,spr07_erase
        m_sprite_process spr08_data,spr08_erase
        m_sprite_process spr09_data,spr09_erase
        m_sprite_process spr10_data,spr10_erase
        m_sprite_process spr11_data,spr11_erase
        m_sprite_process spr12_data,spr12_erase
        m_sprite_process spr13_data,spr13_erase
        m_sprite_process spr14_data,spr14_erase
        m_sprite_process spr15_data,spr15_erase

        m_sprite_process spr20_data,spr20_erase
;        m_sprite_process spr21_data,spr21_erase
        m_sprite_process spr22_data,spr22_erase
        m_sprite_process spr23_data,spr23_erase
 ;       m_sprite_process spr24_data,spr24_erase
 ;       m_sprite_process spr25_data,spr25_erase
 ;       m_sprite_process spr26_data,spr26_erase

;        m_sprite_process spr27_data,spr27_erase
;        m_sprite_process spr28_data,spr28_erase
;        m_sprite_process spr29_data,spr29_erase
;        m_sprite_process spr30_data,spr30_erase

;        m_sprite_process spr31_data,spr31_erase

        ld      a, 1Ch
        ld      (regbase6C+SYSREG), a
        ;ei
        ret

process_sprite_erase:
        ;di
        ld      a, 6Ch
        ld      (regbase1C+SYSREG), a

        ld      a, _WL__2|_LAYER_MODE_W|0
        ld      (regbase6C+NCREG), a
        ld      bc,64-2     

;apple
        m_sprite_erase spr19_erase
;falling kashtan
        m_sprite_erase spr16_erase
        m_sprite_erase spr17_erase
        m_sprite_erase spr18_erase


 ;        m_sprite_erase spr04_erase
        m_sprite_erase spr05_erase
        m_sprite_erase spr06_erase
;        m_sprite_erase spr07_erase
        m_sprite_erase spr08_erase
        m_sprite_erase spr09_erase
        m_sprite_erase spr10_erase
        m_sprite_erase spr11_erase
        m_sprite_erase spr12_erase
        m_sprite_erase spr13_erase
        m_sprite_erase spr14_erase
        m_sprite_erase spr15_erase

        m_sprite_erase spr20_erase
;        m_sprite_erase spr21_erase
        m_sprite_erase spr22_erase
        m_sprite_erase spr23_erase
;        m_sprite_erase spr24_erase
;        m_sprite_erase spr25_erase
;        m_sprite_erase spr26_erase

;        m_sprite_erase spr27_erase
;        m_sprite_erase spr28_erase
;        m_sprite_erase spr29_erase
;        m_sprite_erase spr30_erase

;        m_sprite_erase spr31_erase

        ld      a, 1Ch
        ld      (regbase6C+SYSREG), a
        ;ei
        ret


sprite_show__cntr:      db      0
sprite_show__cntr2:      db      0

sprite_show:

        ld      a,(sprite_show__cntr2)
        inc     a
        ld      (sprite_show__cntr2),a

        ld      a,h
        or      l
        ret     z

        ld      a,(sprite_show__cntr)
        inc     a
        ld      (sprite_show__cntr),a


        ld      a, _WL__2|_LAYER_MODE_W|1
        ld      (regbase6C+NCREG), a

        ld      bc,64-2
        ld      a,0ffh
        dup     16
                ld      a,(de)
                ld      (hl), a
                inc     hl
                inc     de
                ld      a,(de)
                ld      (hl), a
                inc     hl
                inc     de
                ld      a,(de)
                ld      (hl), a
                ;inc     hl
                inc     de
                add     hl, bc
        edup
        ret

sprite_erase__cntr:     db      0
sprite_erase__cntr2:     db      0

sprite_erase:

        ld      a,(sprite_erase__cntr2)
        inc     a
        ld      (sprite_erase__cntr2),a

        ld      a,(sprite_erase__cntr)
        inc     a
        ld      (sprite_erase__cntr),a

        ld      a,0ffh
        dup     16
                ld      (hl), a
                inc     hl
                ld      (hl), a
                inc     hl
                ld      (hl), a
                add     hl, bc
        edup
        ret        

;       db y,x,sprid,color
;de - sprptr
;hl - scraddr

sprite_get_addr:
        ld      a, (hl)
        cp      192
        jp      c, get_new_spr_addr     ; y < 192 ?
noSprite:
        ld      hl, 0
        ld      d, b
        ld      e, c
        ret

;a - sprid*4
;b - x
;c - y

;hl - sprptr
;de - scraddr

get_new_spr_addr:
        ld      c,a
        inc     hl
        ld      b,(hl)
        inc     hl
        inc     hl
        ld      a,(hl)
        or      a
        jp      z,noSprite
        dec     hl

        ld      a,(hl)
        ld      l,a             ;sprid*4

;get_new_spr_addr:
        ld      h,0     
        add     hl,hl           ;sprid*8
        
        ld      a,b     
        and     7       
        or      l       
        ld      l,a             ;sprid*8+x
        add     hl,hl           ;*2
        ld      de,sprite_addr
        add     hl,de           ;spr spr addr

        ld      e,(hl)
        inc     hl
        ld      h,(hl)
        ld      l,e

        ld      (retspraddr+1),hl

        ;y*64+(x/8)+scrbase

        ld      a,c
        rrca
        rrca
        ld      e,a
        and     3fh
        ld      d,a

        ld      a,e
        and     0c0h
        ld      e,a             ;de=y*64

        ld      a,b
        rrca
        rrca
        rrca
        and     1fh
        or      e
        ld      e,a             ;de=y*64+(x/8)
        ld      hl,GZU_BASE
        add     hl,de           ;scraddr
retspraddr:
        ld      de,0            ;sprite addr
        scf
        ret


;spr00_data	EQU	_Sprite_00
;spr01_data	EQU	_Sprite_01
;spr02_data	EQU	_Sprite_02
;spr03_data	EQU	_Sprite_03
spr04_data	EQU	_Sprite_04_Hair
spr05_data	EQU	_Sprite_05_Face
spr06_data	EQU	_Sprite_06_Body
spr07_data	EQU	_Sprite_07_Foot
spr08_data	EQU	_Sprite_08_Shadow
spr09_data	EQU	_Sprite_09_BridgeLeft
spr10_data	EQU	_Sprite_10_BridgeRight
spr11_data	EQU	_Sprite_11_Fish1
spr12_data	EQU	_Sprite_12_Fish2
spr13_data	EQU	_Sprite_13_Fish3
spr14_data	EQU	_Sprite_14_Ball
spr15_data	EQU	_Sprite_15_Ball2
spr16_data	EQU	_Sprite_16_Falling1
spr17_data	EQU	_Sprite_17_Falling2
spr18_data	EQU	_Sprite_18_Falling3
spr19_data	EQU	_Sprite_19_Apple
spr20_data	EQU	_Sprite_20_Bee
spr21_data	EQU	_Sprite_21_BeeBlackStripes
spr22_data	EQU	_Sprite_22_Stone
spr23_data	EQU	_Sprite_23_Bonus1
;spr24_data	EQU	_Sprite_24
;spr25_data	EQU	_Sprite_25
;spr26_data	EQU	_Sprite_26
spr27_data	EQU	_Sprite_27_Life1
spr28_data	EQU	_Sprite_28_Life2
spr29_data	EQU	_Sprite_29_Life3
spr30_data	EQU	_Sprite_30_Life4
;spr31_data	EQU	_Sprite_31_FireVegetable??

SS1=$

        display /A,"SPROUT2SIZE:",SS1-SS0               