_int_handler:
	di
        push    af
        push    bc
        push    de
        push    hl

;SOUND
        call    SoundProcInt
        call    doSOUND1
;SOUND

        ;mdebug_lut 00000001b

        ;update sprite if required
        ld      a,(RequireSpriteUpdate)
        or      a
        jp      z,noSpriteUpdateRequired

        mdebug_lut 00010001b

        call    process_sprite

        
        xor     a
        ld      (RequireSpriteUpdate),a
noSpriteUpdateRequired:



        mdebug_lut 00100001b


        call    CheckSndOnOff

        ld      a, (g_Flags)       ; 6 4 - Game Flag (no demo)?
        and     40h ; '@'
        call    nz, InputCheck
 
        call    _MainGameLoop

        mdebug_lut 01000001b

        ;update PNT if required
        ld      a,(RequireScreenUpdate)
        or      a
        jp      z,noPNTUpdateRequired
;        ld      hl,PNT
        call    show_pnt
        xor     a
        ld      (RequireScreenUpdate),a
noPNTUpdateRequired:

;        mdebug_lut 01110001b
        mdebug_lut 00000001b

        ld      a,020h
        ld      (portbase1C+PIC_RUS), a

        pop     hl
        pop     de
        pop     bc
        pop     af
        ei
        ret

RequireScreenUpdate:
        db      1
RequireSpriteUpdate:
        db      1

VBL_CNTR:
        db      0